﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        List<Int64[]> onMintermler = new List<Int64[]>();
        List<Int64[]> offMintermler = new List<Int64[]>();
        List<Int64[]> onMintermlerYdk = new List<Int64[]>();
        List<Int64[]> offMintermlerYdk = new List<Int64[]>();
        List<int> dcMintermler = new List<int>();
        List<Int64[]> q1_Kumesi = new List<Int64[]>();
        List<Int64[]> s1_Kumesi = new List<Int64[]>();
        List<Int64[]> AI_Kumesi = new List<Int64[]>();
        List<SW_yapi> SW_ler = new List<SW_yapi>();
        int onMinSayisi = 0, offMinSayisi = 0, dcMinSayisi = 0;
        double yakinSure, izoleYakinSure, kesinSure, izoleKesinSure, yakinSurePrl, izoleYakinSurePrl, kesinSurePrl, izoleKesinSurePrl;    
        int girisSayisi = 1, cikisSayisi = 1;
        Int64 uzun1 = 1;
        
        Stopwatch sayac = new Stopwatch();

        public Form1()
        {

            Control.CheckForIllegalCrossThreadCalls = false;
            InitializeComponent();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            string str = "\r\n";  //textbox'ta alt satıra geç
            OZET.AppendText(str+openFileDialog1.SafeFileName+" "+girisSayisi.ToString()+" "+onMinSayisi.ToString()+" "+offMinSayisi.ToString()+str);
            OZET.AppendText(Environment.NewLine);

            // SERİ PROGRAMLAMA İLE SADELEŞTİRME
            button4_Click(sender, e);
            OZET.AppendText("Yakın AI: "+ AI_Kumesi.Count + str+"Yakın Süre: "+yakinSure+str);
         
            button6_Click(sender, e);
            OZET.AppendText("İzoleYakın AI: " + AI_Kumesi.Count + str + "İzoleYakın Süre: " + izoleYakinSure +str);

            button2_Click(sender, e);
            OZET.AppendText("KesinSonuç AI: " + AI_Kumesi.Count + str + "Kesin Süre: " + kesinSure +str);

            button3_Click_1(sender, e);
            OZET.AppendText("İzoleKesin AI: " + AI_Kumesi.Count + str + "İzoleKesin Süre: " + izoleKesinSure +str+str);



            // PARALEL PROGRAMLAMA İLE SADELEŞTİRME
            button7_Click(sender, e);
            OZET.AppendText("Yakın AI: " + AI_Kumesi.Count + str + "YakınPrl Süre: " + yakinSurePrl + str);

            button8_Click(sender, e);
            OZET.AppendText("İzoleYakın AI: " + AI_Kumesi.Count + str + "İzoleYakınPrl Süre: " + izoleYakinSurePrl + str);

            button9_Click(sender, e);
            OZET.AppendText("KesinSonuç AI: " + AI_Kumesi.Count + str + "KesinPrl Süre: " + kesinSurePrl + str);

            button10_Click(sender, e);
            OZET.AppendText("İzoleKesin AI: " + AI_Kumesi.Count + str + "İzoleKesinPrl Süre: " + izoleKesinSurePrl );


        }

        private void degiskenleriTemizle()  //Her hesaplamadan önce bütün değişkenler ve listeler temizleniyor
        {
            onMintermler = onMintermlerYdk.ToList();
            offMintermler = offMintermlerYdk.ToList();
            q1_Kumesi.Clear();
            s1_Kumesi.Clear();
            AI_Kumesi.Clear();
            SW_ler.Clear();
            onMintermler.Clear();
            offMintermler.Clear();
            onMintermler = onMintermlerYdk.ToList();
            offMintermler = offMintermlerYdk.ToList();
        }


        private void button4_Click(object sender, EventArgs e)   //YAKIN MİNİMUM HESAPLAMA
        {
            degiskenleriTemizle(); 

            sayac.Restart();
            yakin_minimum();
            yazdir(listBox4);            
            sayac.Stop();
            
            yakinSure=sayac.Elapsed.TotalMilliseconds;
            label8.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + yakinSure + " ms.";   
        }

        private void button6_Click(object sender, EventArgs e)  //IZOLE MINTERM SIRALAMA ve YAKIN MİNİMUM HESAPLAMA
        {
            degiskenleriTemizle();
            
            sayac.Restart();
            izole_sırala();
            yakin_minimum();
            yazdir(listBox5);
            sayac.Stop();
            
            izoleYakinSure = sayac.Elapsed.TotalMilliseconds;
            label9.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + izoleYakinSure+ " ms.";
        }      

        private void button2_Click(object sender, EventArgs e)      //KESİN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle(); 

            sayac.Restart();
            kesin_minimum();
            yazdir(listBox6);
            sayac.Stop();

            kesinSure = sayac.Elapsed.TotalMilliseconds;
            label10.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + kesinSure + " ms.";  
        }


        private void button3_Click_1(object sender, EventArgs e)        // İZOLE MINTERM SIRALAMA VE KESİN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle(); 

            sayac.Restart();
            izole_sırala();
            kesin_minimum();
            yazdir(listBox7);
            sayac.Stop();

            izoleKesinSure = sayac.Elapsed.TotalMilliseconds;
            label11.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + izoleKesinSure + " ms.";
        }


 //-------------- PARALEL SADELEŞTİRME BUTONLARI-------------------------------------------------------//
        
        private void button7_Click(object sender, EventArgs e) // PARALEL YAKIN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle(); 

            sayac.Restart();                 
            paralel_yakin_minimum();
            yazdir_Paralel(listBox8);
            sayac.Stop();

            yakinSurePrl = sayac.Elapsed.TotalMilliseconds;
            label12.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + yakinSurePrl+ " ms.";
        }

        private void button8_Click(object sender, EventArgs e)  //İZOLE MINTERM SIRALAMA VE PARALEL YAKIN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle();

            sayac.Restart();
            izole_sırala_paralel();
            paralel_yakin_minimum();
            yazdir_Paralel(listBox9);
            sayac.Stop();

            izoleYakinSurePrl = sayac.Elapsed.TotalMilliseconds;
            label13.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + izoleYakinSurePrl+ " ms.";
        }


    
        private void button9_Click(object sender, EventArgs e)  // // PARALEL KESİN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle(); 

            sayac.Restart();
            paralel_kesin_minimum();
            yazdir_Paralel(listBox10);           
            sayac.Stop();

            kesinSurePrl = sayac.Elapsed.TotalMilliseconds;
            label14.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + kesinSurePrl+ " ms.";

        }

        private void button10_Click(object sender, EventArgs e)     //İZOLE MINTERM SIRALAMA VE PARALEL KESİN MİNİMUM SADELEŞTİRME
        {
            degiskenleriTemizle(); 

            sayac.Restart();
            izole_sırala_paralel();
            paralel_kesin_minimum();
            yazdir_Paralel(listBox11);          
            sayac.Stop();

            izoleKesinSurePrl = sayac.Elapsed.TotalMilliseconds;
            label15.Text = "AI No: " + AI_Kumesi.Count + "\r\n" + izoleKesinSurePrl+ " ms.";
        }
             
       
        private void yazdir_Paralel(ListBox listBoxx)
        {
            BackgroundWorker yazdirParalel = new BackgroundWorker();
            yazdirParalel.DoWork += yazdirParalel_DoWork;
            yazdirParalel.RunWorkerAsync(argument: listBoxx);
        }
                       
        // 
        private void yazdirParalel_DoWork(object sender, DoWorkEventArgs e)
        {
            ListBox listBoxx = (ListBox)e.Argument;
            List<StringBuilder> satirlar = new List<StringBuilder>();

             var AI_Kumes = AI_Kumesi.ToList();
             Parallel.ForEach(AI_Kumes, AIs =>          
             {
                 System.Text.StringBuilder satir = new System.Text.StringBuilder(Convert.ToString(AIs[0], 2).PadLeft(girisSayisi, '0'));
                 string x_ler = Convert.ToString((AIs[0] & AIs[1]), 2).PadLeft(girisSayisi, '0');   // X leri bulmak için her iki sayı "and" yapıldı. 1-1 olanlar bulundu.
                 for (int m = 0; m < girisSayisi; m++)
                 {
                     if (x_ler[m] == '1') satir[m] = 'x';
                 }
                 satirlar.Add(satir);
             });             
            listBoxx.DataSource = satirlar.ToList();
        }

         
        private void yazdir(ListBox listBoxx)
        {
            listBoxx.Items.Clear();
            foreach (Int64[] AIs in AI_Kumesi)
            {
                System.Text.StringBuilder satir = new System.Text.StringBuilder(Convert.ToString(AIs[0], 2).PadLeft(girisSayisi, '0'));
                string x_ler = Convert.ToString((AIs[0] & AIs[1]), 2).PadLeft(girisSayisi, '0');   // X leri bulmak için her iki sayı "and" yapıldı. 1-1 olanlar bulundu.
                for (int m = 0; m < girisSayisi; m++)
                {
                    if (x_ler[m] == '1') satir[m] = 'x';
                }
                listBoxx.Items.Add(satir.ToString());
            }
        }

      

        private void button5_Click(object sender, EventArgs e)  //FORM RESETLEME 
        {
            System.Diagnostics.Process.Start(Application.ExecutablePath);
            this.Close();
        }
        

        private void button1_Click(object sender, EventArgs e)      // DOSYA YÜKLEME
        {            
            try
            {
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    string[] dosyaSatirlari = File.ReadAllLines(openFileDialog1.FileName);  
                    label6.Text = openFileDialog1.SafeFileName;
                    listBox1.Items.Add("DOSYA ADI: " + openFileDialog1.SafeFileName);
                    foreach (string satir in dosyaSatirlari)
                    {
                        if (satir.Substring(0, 1).Equals("."))
                        {
                            switch (satir.Substring(0, 2))
                            { 
                                case ".i":   girisSayisi = Convert.ToInt32(satir.Substring(2));listBox1.Items.Add("GİRİŞ DEĞİŞKENİ: " + satir.Substring(2)); break;
                                case ".o":  cikisSayisi = Convert.ToInt32(satir.Substring(2)); break; 
                                default: break;
                            }
                        }
                        else if (satir.Substring((satir.Length - 1), 1) == "1")
                        {
                            Int64 say = Convert.ToInt64(satir.Substring(0, (satir.Length - 2)), 2);
                            Int64[] sayi= new Int64[2];
                            sayi[0] = say;
                            sayi[1] = ~say;
                            onMintermler.Add(sayi);
                            listBox2.Items.Add(satir.Substring(0, (satir.Length - 2)));
                        }
                        else if (satir.Substring((satir.Length - 1), 1) == "0")
                        {
                            Int64 say = Convert.ToInt64(satir.Substring(0, (satir.Length - 2)), 2);
                            Int64[] sayi = new Int64[2];
                            sayi[0] = say;
                            sayi[1] = ~say;
                            offMintermler.Add(sayi);
                            listBox3.Items.Add(satir.Substring(0, (satir.Length - 2)));
                        }
                        else
                        {
                          
                        }
                    }
                }                
                onMinSayisi = onMintermler.Count();
                offMinSayisi = offMintermler.Count();
                dcMinSayisi = dcMintermler.Count();
                listBox1.Items.Add("ON MİNTERMİ SAYISI: " + onMinSayisi);
                listBox1.Items.Add("OFF MİNTERMİ SAYISI: " + offMinSayisi);
                listBox1.Items.Add("DC MİNTERMİ SAYISI: " + dcMinSayisi);
                onMintermlerYdk = onMintermler.ToList();
                offMintermlerYdk = offMintermler.ToList();
                SERI.Enabled = true; button2.Enabled = true; button3.Enabled = true; button4.Enabled = true; button6.Enabled = true;
                button7.Enabled = true; button8.Enabled = true; button9.Enabled = true; button10.Enabled = true;
                button1.Enabled = false;
            }
            catch (Exception)
            { MessageBox.Show("lütfen seçtiğiniz dosyayı kontrol ediniz.Dosyada hata(lar) var."); }           
        }
  


        private void izole_sırala()
        {
            List<listYapi> izoleLst = new List<listYapi>();     //sıralamanın yapılacağı liste
            for (int a = 0; a < onMinSayisi; a++)                     //bu listeye on mintermlerini ata
            {   listYapi eleman = new listYapi();
                eleman.minterm=onMintermler[a][0];
                izoleLst.Add(eleman);
            }
            foreach (listYapi siradaki in izoleLst)             //listedeki her elemanı off mintermleri ile karşılaştır
            {
                for (int b = 0; b < offMinSayisi; b++)
                {
                    Int64 sonuc = 0;
                    sonuc = siradaki.minterm ^ offMintermler[b][0];                  //on ve off mintermleri exor yapılıp arada kaç karakter fark olduğu hesaplanıyor.
                    
                    sonuc = sonuc - ((sonuc >> 1) & 0x55555555);
                    sonuc = (sonuc & 0x33333333) + ((sonuc >> 2) & 0x33333333);
                    sonuc = (((sonuc + (sonuc >> 4)) & 0x0f0f0f0f) * 0x01010101) >> 24;
                   
                    siradaki.katsayi = siradaki.katsayi + sonuc;
                    if (sonuc == 1) { siradaki.komsuSayisi++; }                   
                }
            }
                        
            List<listYapi> sirali_liste = izoleLst.OrderBy(o => o.katsayi).ToList();        //siralanmış bir liste oluşturdum.
            onMintermler.Clear();
            foreach (listYapi madde in sirali_liste)                                            //siralanmış listedeki mintermler onMintermler kümesine yazdırılıyor.
            {  
              Int64[] sayi2= new Int64[2];
              sayi2[0] = madde.minterm;
              sayi2[1] = ~madde.minterm;
              onMintermler.Add(sayi2);             
            }
        }

        private void izole_sırala_paralel()
        {
            List<listYapi> izoleLst = new List<listYapi>();     //sıralamanın yapılacağı listeyi tanımladım. 
            for (int a = 0; a < onMinSayisi; a++)                     // bu listeye on mintermlerini atadım. Parallel yapınca hiç hız farkı olmadı.
            {
                listYapi eleman = new listYapi();
                eleman.minterm = onMintermler[a][0];
                izoleLst.Add(eleman);
            }
            Parallel.ForEach(izoleLst, siradaki =>    //             //listedeki her elemanı off mintermleri ile karşılaştıracağım.
            {
                for (int b = 0; b < offMinSayisi; b++)
                {
                    Int64 sonuc = 0;
                    sonuc = siradaki.minterm ^ offMintermler[b][0];                          //on ve off mintermleri exor yapılıp arada kaç karakter fark olduğu hesaplanıyor.

                    sonuc = sonuc - ((sonuc >> 1) & 0x55555555);
                    sonuc = (sonuc & 0x33333333) + ((sonuc >> 2) & 0x33333333);
                    sonuc = (((sonuc + (sonuc >> 4)) & 0x0f0f0f0f) * 0x01010101) >> 24;

                    siradaki.katsayi = siradaki.katsayi + sonuc;
                    if (sonuc == 1) { siradaki.komsuSayisi++; }
                }
            });

            List<listYapi> sirali_liste = izoleLst.OrderBy(o => o.katsayi).ToList();        //siralanmış bir liste oluşturdum.
            onMintermler.Clear();
            foreach (listYapi madde in sirali_liste)    //siralanmış listedeki mintermler onMintermler kümesine yazdırılıyor. Paralel denedim, yanlış sırada aktardı, sonuç tutarsız oldu, izole sıralama farklı oluyor. 
            {
                Int64[] sayi2 = new Int64[2];
                sayi2[0] = madde.minterm;
                sayi2[1] = ~madde.minterm;
                onMintermler.Add(sayi2);
            }
        }

        private void yakin_minimum()
        {
            while (onMintermler.Count() > 0)
            {
                //Q0 veQ1 kümeleri oluşturuluyor-----------------------------
                bool ilk = true; q1_Kumesi.Clear();
                foreach (Int64[] off in offMintermler)
                {
                    Int64[] q0 = new Int64[2];
                    q0[0] = onMintermler[0][1] | off[0];
                    q0[1] = onMintermler[0][0] | off[1];
                    if (ilk)
                    {
                        q1_Kumesi.Add(q0); ilk = false;
                    }
                    else
                    {
                        kapsaniyormu(q0);
                    }
                }


                //S1 kümesi oluşturuluyor-----------------------------
                Int64[] D = new Int64[2];
                D[0] = Convert.ToInt64(uzun1 << girisSayisi);
                D[0]--;
                Int64 enbuyuk = D[0];
                D[1] = D[0];
                s1_Kumesi.Clear();
                s1_Kumesi.Add(D);  // S1 kumesine tam kume ekledim. 

                foreach (Int64[] q1_ler in q1_Kumesi)
                {
                    List<Int64[]> s1_ydk = new List<Int64[]>();

                    foreach (Int64[] s1_ler in s1_Kumesi)
                    {
                        Int64 cTm = 0;
                        Int64 cBs = 0;
                        cTm = (~((s1_ler[0] & s1_ler[1]) | (q1_ler[0] & q1_ler[1]))) & (s1_ler[0] ^ q1_ler[0]);//eger cTm!=0 ise vi=y durumu yani C=A kupu, cikarma mumkun degil.
                        cTm = cTm & enbuyuk;
                        cBs = (q1_ler[0] & q1_ler[1]) | (~(q1_ler[1] ^ s1_ler[1]) & ~(s1_ler[0] & s1_ler[1])); //  eger cBs=ox111111..11 yani  4.29.... ise sonuc boskume, geriye bisey kalmiyor.

                        if (cTm != 0)     //sıfırdan farklıysa çıkarma işlemi yapılmıyor; C=A durumu.
                        {
                            int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                            foreach (Int64[] s11 in s1_ydk)
                            {
                                C[0] = s1_ler[0] & s11[0];
                                C[1] = s1_ler[1] & s11[1];
                                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                bos--;
                                bos = (C[0] | C[1]) ^ bos;
                                if (bos == 0)
                                {
                                    if ((C[0] == s1_ler[0]) && (C[1] == s1_ler[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                    else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = s1_ler[0]; s11[1] = s1_ler[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                }
                            }
                            if (sonuc == 0) s1_ydk.Add(s1_ler);
                        }
                        else if (cBs != 4294967295)   // eşit olsaydı sonuç boşküme, cikarma sonucu bişey kalmıyordu.
                        {
                            Int64 Vj = 0;

                            Vj = (s1_ler[0] & s1_ler[1]) & ~(q1_ler[0] & q1_ler[1]);   //A nin yıldız, b nin 0-1 olduğu durumlar 1 oluyor.
                            Int64 F = 0;
                            for (int i = 0; i < girisSayisi; i++)
                            {
                                F = (Vj >> i) & 1;     //İ. değer 1 e eşitmi değilmi diye kontrol ettim
                                if (F == 1)
                                {
                                    Int64[] E = new Int64[2];
                                    E[0] = Convert.ToInt64((s1_ler[0] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[0]))); // ilk parantezde A'nın i. bitini kaldırdım, sonra onu B-degil degeri ile degiştirdim.  
                                    E[1] = Convert.ToInt64((s1_ler[1] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[1])));


                                    int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                                    foreach (Int64[] s11 in s1_ydk)
                                    {
                                        C[0] = E[0] & s11[0];
                                        C[1] = E[1] & s11[1];
                                        Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                        bos--;
                                        bos = (C[0] | C[1]) ^ bos;
                                        if (bos == 0)
                                        {
                                            if ((C[0] == E[0]) && (C[1] == E[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                            else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = E[0]; s11[1] = E[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                        }
                                    }
                                    if (sonuc == 0) s1_ydk.Add(E);
                                }
                            }
                        }
                    }
                    s1_Kumesi.Clear();
                    s1_Kumesi = s1_ydk;
                }
                int kln = 1000, kln2 = 0;
                Int64[] en_S1 = new Int64[2];
                foreach (Int64[] s11 in s1_Kumesi)
                {
                    kln2 = kalanlar(s11).Count();
                    if (kln2 < kln)
                    {
                        en_S1 = s11; kln = kln2;
                    }
                }
                AI_Kumesi.Add(en_S1);                             
                onMintermler = kalanlar(en_S1);               
            }           
        }


        private void paralel_yakin_minimum()
        {
            while (onMintermler.Count() > 0)
            {
                bool ilk = true; q1_Kumesi.Clear();
                foreach (Int64[] off in offMintermler)   //kapsanıyormu fonksiyonu q1 kümesine ekleme yapıyor, koleksiyon değiştiği için çakışıyor.
                {
                    Int64[] q0 = new Int64[2];
                    q0[0] = onMintermler[0][1] | off[0];
                    q0[1] = onMintermler[0][0] | off[1];
                    if (ilk)
                    {
                        q1_Kumesi.Add(q0); ilk = false;
                    }
                    else
                    {
                        kapsaniyormu(q0);    // süre uzuyor...
                    }
                }
                
                Int64[] D = new Int64[2];
                D[0] = Convert.ToInt64(uzun1 << girisSayisi);
                D[0]--;
                Int64 enbuyuk = D[0];
                D[1] = D[0];
                s1_Kumesi.Clear();
                s1_Kumesi.Add(D);  // S1 kumesine tam kume ekledim. 

                foreach (Int64[] q1_ler in q1_Kumesi)     //alttaki foreach için koleksiyon değiştirildi hatası veriyor.
                {
                    List<Int64[]> s1_ydk = new List<Int64[]>();

                    foreach (Int64[] s1_ler in s1_Kumesi)     //alttaki foreach'de s1_ydk hata veriyor...
                    {
                        Int64 cTm = 0;
                        Int64 cBs = 0;
                        cTm = (~((s1_ler[0] & s1_ler[1]) | (q1_ler[0] & q1_ler[1]))) & (s1_ler[0] ^ q1_ler[0]);//eger cTm!=0 ise vi=y durumu yani C=A kupu, cikarma mumkun degil.
                        cTm = cTm & enbuyuk;
                        cBs = (q1_ler[0] & q1_ler[1]) | (~(q1_ler[1] ^ s1_ler[1]) & ~(s1_ler[0] & s1_ler[1])); //  eger cBs=ox111111..11 yani  4.29.... ise sonuc boskume, geriye bisey kalmiyor.

                        if (cTm != 0)     //sıfırdan farklıysa çıkarma işlemi yapılmıyor; C=A durumu.
                        {
                            int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                            foreach (Int64[] s11 in s1_ydk) //Parallel.ForEach(s1_ydk, (s11, state)=>  // ÇOK AZ BİR YAVAŞLAMA OLUYOR
                            {
                                C[0] = s1_ler[0] & s11[0];
                                C[1] = s1_ler[1] & s11[1];
                                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                bos--;
                                bos = (C[0] | C[1]) ^ bos;
                                if (bos == 0)
                                {
                                    if ((C[0] == s1_ler[0]) && (C[1] == s1_ler[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                    else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = s1_ler[0]; s11[1] = s1_ler[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                }
                            }
                            if (sonuc == 0) s1_ydk.Add(s1_ler);
                        }
                        else if (cBs != 4294967295)   // eşit olsaydı sonuç boşküme, cikarma sonucu bişey kalmıyordu.
                        {
                            Int64 Vj = 0;
                            Vj = (s1_ler[0] & s1_ler[1]) & ~(q1_ler[0] & q1_ler[1]);   //A nin yıldız, b nin 0-1 olduğu durumlar 1 oluyor.
                            Int64 F = 0;
                            for (int i = 0; i < girisSayisi; i++)       // aşağıdaki foreach için koleksiyon değiştirildi hatası veriyor. 
                            {
                                F = (Vj >> i) & 1;     //I tried to check if i.th value is equal to 1 or not
                                if (F == 1)
                                {
                                    Int64[] E = new Int64[2];
                                    E[0] = Convert.ToInt64((s1_ler[0] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[0]))); //ilk parantezde A'nın i. bitini kaldırdım, sonra onu B-degil degeri ile degiştirdim.  
                                    E[1] = Convert.ToInt64((s1_ler[1] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[1])));

                                    int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                                    Parallel.ForEach(s1_ydk, (s11, state) =>     
                                    {
                                        C[0] = E[0] & s11[0];
                                        C[1] = E[1] & s11[1];
                                        Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                        bos--;
                                        bos = (C[0] | C[1]) ^ bos;
                                        if (bos == 0)
                                        {
                                            if ((C[0] == E[0]) && (C[1] == E[1])) { sonuc = 1; state.Break(); } //q00 kapsaniyor
                                            else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = E[0]; s11[1] = E[1]; sonuc = 2; state.Break(); } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                        }
                                    });
                                    if (sonuc == 0) s1_ydk.Add(E);
                                }
                            }
                        }
                    }
                    s1_Kumesi.Clear();
                    s1_Kumesi = s1_ydk;
                }
                int kln = 1000, kln2 = 0;
                Int64[] en_S1 = new Int64[2];

                foreach (Int64[] s11 in s1_Kumesi)  //  Paralel yapılırsa farklı sonuç çıkıyor, hatalı çalışıyor.
                {
                    kln2 = kalanlar(s11).Count();
                    if (kln2 < kln)
                    {
                        en_S1 = s11; kln = kln2;
                    }
                }
                AI_Kumesi.Add(en_S1);
                onMintermler = kalanlar(en_S1);
            }            
        }

        private void kesin_minimum()
        {
            while (onMintermler.Count() > 0)
            {
                //Q0 veQ1 kümeleri oluşturuluyor-----------------------------
                bool ilk = true; q1_Kumesi.Clear();
                foreach (Int64[] off in offMintermler)
                {
                    Int64[] q0 = new Int64[2];
                    q0[0] = onMintermler[0][1] | off[0];
                    q0[1] = onMintermler[0][0] | off[1];
                    if (ilk)
                    {
                        q1_Kumesi.Add(q0); ilk = false;
                    }
                    else
                    {
                        kapsaniyormu(q0);
                    }
                }             
                //S1 kümesi oluşturuluyor-----------------------------
                Int64[] D = new Int64[2];
                D[0] = Convert.ToInt64(uzun1 << girisSayisi);
                D[0]--;
                Int64 enbuyuk = D[0];
                D[1] = D[0];
                s1_Kumesi.Clear();
                s1_Kumesi.Add(D);  // S1 kumesine tam kume ekledim. 

                foreach (Int64[] q1_ler in q1_Kumesi)
                {
                    List<Int64[]> s1_ydk = new List<Int64[]>();

                    foreach (Int64[] s1_ler in s1_Kumesi)
                    {
                        Int64 cTm = 0;
                        Int64 cBs = 0;
                        cTm = (~((s1_ler[0] & s1_ler[1]) | (q1_ler[0] & q1_ler[1]))) & (s1_ler[0] ^ q1_ler[0]);//eger cTm!=0 ise vi=y durumu yani C=A kupu, cikarma mumkun degil.
                        cTm = cTm & enbuyuk;
                        cBs = (q1_ler[0] & q1_ler[1]) | (~(q1_ler[1] ^ s1_ler[1]) & ~(s1_ler[0] & s1_ler[1])); //  eger cBs=ox111111..11 yani  4.29.... ise sonuc boskume, geriye bisey kalmiyor.

                        if (cTm != 0)     //sıfırdan farklıysa çıkarma işlemi yapılmıyor; C=A durumu.
                        {

                            int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                            foreach (Int64[] s11 in s1_ydk)
                            {
                                C[0] = s1_ler[0] & s11[0];
                                C[1] = s1_ler[1] & s11[1];
                                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                bos--;
                                bos = (C[0] | C[1]) ^ bos;
                                if (bos == 0)
                                {
                                    if ((C[0] == s1_ler[0]) && (C[1] == s1_ler[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                    else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = s1_ler[0]; s11[1] = s1_ler[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                }
                            }
                            if (sonuc == 0) s1_ydk.Add(s1_ler);

                        }
                        else if (cBs != 4294967295)   // eşit olsaydı sonuç boşküme, cikarma sonucu bişey kalmıyordu.
                        {
                            Int64 Vj = 0;

                            Vj = (s1_ler[0] & s1_ler[1]) & ~(q1_ler[0] & q1_ler[1]);   //A nin yıldız, b nin 0-1 olduğu durumlar 1 oluyor.
                            Int64 F = 0;
                            for (int i = 0; i < girisSayisi; i++)
                            {
                                F = (Vj >> i) & 1;     //I tried to check if i.th value is equal to 1 or not
                                if (F == 1)
                                {
                                    Int64[] E = new Int64[2];
                                    E[0] = Convert.ToInt64((s1_ler[0] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[0]))); //ilk parantezde A'nın i. bitini kaldırdım, sonra onu B-degil degeri ile degiştirdim.  
                                    E[1] = Convert.ToInt64((s1_ler[1] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[1])));


                                    int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                                    foreach (Int64[] s11 in s1_ydk)
                                    {
                                        C[0] = E[0] & s11[0];
                                        C[1] = E[1] & s11[1];
                                        Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                        bos--;
                                        bos = (C[0] | C[1]) ^ bos;
                                        if (bos == 0)
                                        {
                                            if ((C[0] == E[0]) && (C[1] == E[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                            else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = E[0]; s11[1] = E[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                        }
                                    }
                                    if (sonuc == 0) s1_ydk.Add(E);
                                }
                            }
                        }
                    }
                    s1_Kumesi.Clear();
                    s1_Kumesi = s1_ydk;
                }
                //-------- S1 KÜMESİ BENİM AI ADAYLARIM----------------
                //------------------------------------------------------
                List<Int64[]> elde = new List<Int64[]>();

                if (s1_Kumesi.Count == 1)
                {
                    AI_Kumesi.Add(s1_Kumesi[0]);
                    onMintermler = kalanlar(s1_Kumesi[0]);
                    if (SW_ler.Count() > 0) SW_kontrol(s1_Kumesi[0]);
                }
                else    //else bölümü sonuna kadar gitmeli yukarıda döngüden çıkılıyor çünkü..
                {
                    elde = AI_ayikla(s1_Kumesi);    // AI adaylarından kapsananlar çıkarılıyor, hepsini kapsayan tek varmı diye bakılıyor
                    if (elde.Count == 1)
                    {
                        AI_Kumesi.Add(elde[0]);
                        onMintermler = kalanlar(elde[0]);
                        if (SW_ler.Count() > 0) SW_kontrol(elde[0]);
                    }
                    else
                    {
                        SW_yapi yeni_SW = new SW_yapi();
                        yeni_SW.minterm = onMintermler[0];
                        yeni_SW.Adaylar = elde;
                        SW_ler.Add(yeni_SW);

                        onMintermler.Add(onMintermler[0]);
                        onMintermler.RemoveAt(0);
                    }
                }
                if ((SW_ler.Count()>0)&&(SW_ler[0].minterm == onMintermler[0])) SW_leri_EKLE();
                
            }            
        }

              

        private void paralel_kesin_minimum()       
        {
            while (onMintermler.Count() > 0)
            {
                //Q0 veQ1 kümeleri oluşturuluyor-----------------------------
                bool ilk = true; q1_Kumesi.Clear();
                foreach (Int64[] off in offMintermler)
                {
                    Int64[] q0 = new Int64[2];
                    q0[0] = onMintermler[0][1] | off[0];
                    q0[1] = onMintermler[0][0] | off[1];
                    if (ilk)
                    {
                        q1_Kumesi.Add(q0); ilk = false;
                    }
                    else
                    {
                        kapsaniyormu(q0);
                    }
                }
                
                //S1 kümesi oluşturuluyor-----------------------------
                Int64[] D = new Int64[2];
                D[0] = Convert.ToInt64(uzun1 << girisSayisi);
                D[0]--;
                Int64 enbuyuk = D[0];
                D[1] = D[0];
                s1_Kumesi.Clear();
                s1_Kumesi.Add(D);  // S1 kumesine tam kume ekledim. 

                foreach (Int64[] q1_ler in q1_Kumesi)
                {
                    List<Int64[]> s1_ydk = new List<Int64[]>();

                    foreach (Int64[] s1_ler in s1_Kumesi)
                    {
                        Int64 cTm = 0;
                        Int64 cBs = 0;
                        cTm = (~((s1_ler[0] & s1_ler[1]) | (q1_ler[0] & q1_ler[1]))) & (s1_ler[0] ^ q1_ler[0]);//eger cTm!=0 ise vi=y durumu yani C=A kupu, cikarma mumkun degil.
                        cTm = cTm & enbuyuk;
                        cBs = (q1_ler[0] & q1_ler[1]) | (~(q1_ler[1] ^ s1_ler[1]) & ~(s1_ler[0] & s1_ler[1])); //  eger cBs=ox111111..11 yani  4.29.... ise sonuc boskume, geriye bisey kalmiyor.

                        if (cTm != 0)     //sıfırdan farklıysa çıkarma işlemi yapılmıyor; C=A durumu.
                        {
                            int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                            foreach (Int64[] s11 in s1_ydk)
                            {
                                C[0] = s1_ler[0] & s11[0];
                                C[1] = s1_ler[1] & s11[1];
                                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                bos--;
                                bos = (C[0] | C[1]) ^ bos;
                                if (bos == 0)
                                {
                                    if ((C[0] == s1_ler[0]) && (C[1] == s1_ler[1])) { sonuc = 1; break; } //q00 kapsaniyor
                                    else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = s1_ler[0]; s11[1] = s1_ler[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                }
                            }
                            if (sonuc == 0) s1_ydk.Add(s1_ler);
                        }
                        else if (cBs != 4294967295)   // eşit olsaydı sonuç boşküme, cikarma sonucu bişey kalmıyordu.
                        {
                            Int64 Vj = 0;

                            Vj = (s1_ler[0] & s1_ler[1]) & ~(q1_ler[0] & q1_ler[1]);   //A nin yıldız, b nin 0-1 olduğu durumlar 1 oluyor.
                            Int64 F = 0;
                            for (int i = 0; i < girisSayisi; i++)
                            {
                                F = (Vj >> i) & 1;     //I tried to check if i.th value is equal to 1 or not
                                if (F == 1)
                                {
                                    Int64[] E = new Int64[2];
                                    E[0] = Convert.ToInt64((s1_ler[0] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[0]))); //in first brackets, I removed i.th bit of A, then replaced it with "not B" value.  
                                    E[1] = Convert.ToInt64((s1_ler[1] & (~(uzun1 << i))) | ((uzun1 << i) & (~q1_ler[1])));


                                    int sonuc = 0; Int64[] C = new Int64[2];  // yinede kapsaniyormu diye kontrol ediliyor, tekrar eden ifadeler oluşmuyor.
                                    Parallel.ForEach(s1_ydk, (s11, state) =>
                                    {
                                        C[0] = E[0] & s11[0];
                                        C[1] = E[1] & s11[1];
                                        Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                                        bos--;
                                        bos = (C[0] | C[1]) ^ bos;
                                        if (bos == 0)
                                        {
                                            if ((C[0] == E[0]) && (C[1] == E[1])) { sonuc = 1; state.Break(); } //q00 kapsaniyor
                                            else if ((C[0] == s11[0]) && (C[1] == s11[1])) { s11[0] = E[0]; s11[1] = E[1]; sonuc = 2; state.Break(); } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                                        }
                                    });
                                    if (sonuc == 0) s1_ydk.Add(E);
                                }
                            }
                        }
                    }
                    s1_Kumesi.Clear();
                    s1_Kumesi = s1_ydk;
                }
                //-------- S1 KÜMESİ BENİM AI ADAYLARIM----------------
                //------------------------------------------------------
                List<Int64[]> elde = new List<Int64[]>();

                if (s1_Kumesi.Count == 1)
                {
                    AI_Kumesi.Add(s1_Kumesi[0]);
                    onMintermler = kalanlar(s1_Kumesi[0]);
                    if (SW_ler.Count() > 0) SW_kontrol(s1_Kumesi[0]); 
                }
                else    //else bölümü sonuna kadar gitmeli yukarıda döngüden çıkılıyor çünkü..
                {
                    elde = AI_ayikla_Prl(s1_Kumesi);    // AI adaylarından kapsananlar çıkarılıyor, hepsini kapsayan tek varmı diye bakılıyor
                    if (elde.Count == 1)
                    {
                        AI_Kumesi.Add(elde[0]);
                        onMintermler = kalanlar(elde[0]);
                        if (SW_ler.Count() > 0)  SW_kontrol(elde[0]); 
                    }
                    else
                    {
                        SW_yapi yeni_SW = new SW_yapi();
                        yeni_SW.minterm = onMintermler[0];
                        yeni_SW.Adaylar = elde;
                        SW_ler.Add(yeni_SW);

                        onMintermler.Add(onMintermler[0]);
                        onMintermler.RemoveAt(0);
                    }
                }
                if ((SW_ler.Count() > 0) && (SW_ler[0].minterm == onMintermler[0])) SW_leri_EKLE();

            }
        }

            

        private void SW_leri_EKLE()
        {
            var siraliSW= SW_ler.OrderBy(SW_ler => SW_ler.Adaylar.Count());
            onMintermler.Clear();
            foreach (SW_yapi mintler in siraliSW)
            {
                onMintermler.Add(mintler.minterm);
            }            

            Int64[] Current_Min = new Int64[2];
            int kln = 1000, kln2 = 0;
            Int64[] en_S1 = new Int64[2];

            while (onMintermler.Count>0)
            {
                Current_Min = onMintermler[0];
                onMintermler.RemoveAt(0);
                foreach(SW_yapi sw in siraliSW)
                {
                    if(Current_Min==sw.minterm)
                    {
                        kln = 1000; kln2 = 0;
                        foreach (Int64[] adaylar in sw.Adaylar)
                        {
                            kln2 = kalanlar(adaylar).Count();
                            if (kln2 < kln)
                            {
                                en_S1 = adaylar; kln = kln2;
                            }
                        }
                        AI_Kumesi.Add(en_S1);
                        onMintermler = kalanlar(en_S1);
                        break;
                    }
                }
            }       
        }

        List<Int64[]> kalanlar(Int64[] Aimp)
        {
            List<Int64[]> kalan = new List<Int64[]>();
            Int64[] C = new Int64[2];
            kalan.Clear();
            foreach (Int64[] onM in onMintermler)
            {
                C[0] = Aimp[0] & onM[0];
                C[1] = Aimp[1] & onM[1];
                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                bos--;
                bos = (C[0] | C[1]) ^ bos;
                if (bos != 0 || C[0] != onM[0])
                {
                    kalan.Add(onM);
                }
            }
            return kalan;
        }


        private void SW_kontrol(Int64[] yeni_AI)  //  nesne başvurusu problem çıkaryor.
        {
            List<SW_yapi> sw_ydk = new List<SW_yapi>();          
            //---------- SW minterm kontrolü-------------------------------            
            foreach (SW_yapi sw in SW_ler)      //SW'ler için minterm kontrolü, minterm yeni bulunan 
            {                                   //AI tarafından kapsanıyorsa SW'ler listesine alınmıyor
                Int64[] C = new Int64[2];
                C[0] = yeni_AI[0] & sw.minterm[0];
                C[1] = yeni_AI[1] & sw.minterm[1];
                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                bos--;
                bos = (C[0] | C[1]) ^ bos;
                if (bos != 0 || C[0] != sw.minterm[0])
                {
                    sw_ydk.Add(sw);
                }
            }
            SW_ler.Clear();
            SW_ler = sw_ydk;            
        }
        
        private void SW_kontrol_AI()
        {
            //-----------SW AI kontrolu---------------------
            List<SW_yapi> sw_ydk2 = new List<SW_yapi>();
            List<Int64[]> elde = new List<Int64[]>();
            
            foreach (SW_yapi sw2 in SW_ler)      //SW'ler için AI kontrolü
            {
                elde = AI_ayikla(sw2.Adaylar.ToList());    // AI adaylarından kapsananlar çıkarılıyor, hepsini kapsayan tek varmı diye bakılıyor
                if (elde.Count == 1)
                {
                    AI_Kumesi.Add(elde[0]);
                    onMintermler = kalanlar(elde[0]);
                    if (SW_ler.Count() > 0) SW_kontrol(elde[0]);
                    if (onMintermler.Count() == 0) break;
                }
                else sw_ydk2.Add(sw2);
            }
            SW_ler.Clear();
            SW_ler = sw_ydk2;
        }

      

        List<Int64[]> AI_ayikla (List<Int64[]> AI_adaylar)
        {
            List<Int64[]> AI_lar = new List<Int64[]>(); int sonuc=0;          
            List<Int64[]> silinecekler = new List<Int64[]>();             
            while (AI_adaylar.Count>0)
            {
                Int64[] islenen = AI_adaylar[0]; AI_adaylar.RemoveAt(0); 
                foreach (Int64[] AI_aday in AI_adaylar)
                {
                    sonuc=AI_karsilastir(islenen,AI_aday);
                    if (sonuc == 1) { silinecekler.Add(islenen); }         // islenen = AI_aday; }
                    else if (sonuc == 2) silinecekler.Add(AI_aday);                     
                }
           
                if ( !AI_lar.Contains(islenen))  AI_lar.Add(islenen);           
            }

            foreach (Int64[] sil in silinecekler)
            { AI_lar.Remove(sil); }                        
            return AI_lar;
        }


        List<Int64[]> AI_ayikla_Prl(List<Int64[]> AI_adaylar)
        {
            List<Int64[]> AI_lar = new List<Int64[]>(); int sonuc = 0;
            List<Int64[]> silinecekler = new List<Int64[]>();

            while (AI_adaylar.Count > 0)
            {
                Int64[] islenen = AI_adaylar[0]; AI_adaylar.RemoveAt(0);
                foreach (Int64[] AI_aday in AI_adaylar)
                {
                    sonuc = AI_karsilastir(islenen, AI_aday);

                    if (sonuc == 1) { silinecekler.Add(islenen); islenen = AI_aday; }
                    else if (sonuc == 2) silinecekler.Add(AI_aday);
                }

                if (!AI_lar.Contains(islenen)) AI_lar.Add(islenen);
            }
            
            foreach (Int64[] sil in silinecekler)
            {
                AI_lar.Remove(sil);
            }
            return AI_lar;
        }


        int AI_karsilastir(Int64[] AI_1, Int64[] AI_2)
        {
            List<Int64[]> kapsananlar1 = kapsanan_ON_mins(AI_1);
            List<Int64[]> kapsananlar2 = kapsanan_ON_mins(AI_2);
            List<Int64[]> aynilar = new List<Int64[]>();
            Int64 C=new Int64();
            foreach (Int64[] kps1 in kapsananlar1 )
            {
                foreach ( Int64[] kps2 in kapsananlar2)
                {
                    C=(kps1[0]^kps2[0]) | (kps1[1]^kps2[1]);    // sonuç sıfır ise her iki minterm aynıdır.
                    if (C==0) aynilar.Add(kps2);
                }
            }
            int ortak = aynilar.Count();
            if (kapsananlar1.Count()==ortak) return 1;      // AI_2 daha buyuk, kapsiyor
            if (kapsananlar2.Count() == ortak) return 2;      //AI_1 daha buyuk, kapsiyor
            return 3;
        }
        int AI_karsilastir_Prl(Int64[] AI_1, Int64[] AI_2)    //yavaşlatıyor, yukarıdaki seri daha hızlı çalışıyor
        {
            List<Int64[]> kapsananlar1 = kapsanan_ON_mins(AI_1);
            List<Int64[]> kapsananlar2 = kapsanan_ON_mins(AI_2);
            List<Int64[]> aynilar = new List<Int64[]>();
            Int64 C = new Int64();
            Parallel.ForEach(kapsananlar1, (kps1, state) =>
           {
               foreach (Int64[] kps2 in kapsananlar2)
               {
                   C = (kps1[0] ^ kps2[0]) | (kps1[1] ^ kps2[1]);    // sonuç sıfır ise her iki minterm aynıdır.
                    if (C == 0) aynilar.Add(kps2);
               }
           });
            int ortak = aynilar.Count();
            if (kapsananlar1.Count() == ortak) return 1;      // AI_2 daha buyuk, kapsiyor
            if (kapsananlar2.Count() == ortak) return 2;      //AI_1 daha buyuk, kapsiyor
            return 3;
        }


        List<Int64[]> kapsanan_ON_mins (Int64[] Aimp)
        {
            List<Int64[]> kapsanan = new List<Int64[]>();
            Int64[] C = new Int64[2];
            foreach (Int64[] onM in onMintermler)
            {
                C[0] = Aimp[0] & onM[0];
                C[1] = Aimp[1] & onM[1];
                Int64 bos = Convert.ToInt64(uzun1 << girisSayisi);  //bu sayı Int64'de 111...111 degeri.
                bos--;
                bos = (C[0] | C[1]) ^ bos;
                if (bos == 0 && C[0]==onM[0])
                {
                    kapsanan.Add(onM);
                }
            } return kapsanan;
        }

        
        class SW_yapi
        {
            public Int64[] minterm { get; set; }
            public List<Int64[]> Adaylar { get; set; }
        }

        class listYapi
        {
            public Int64 minterm { get; set; }
            public int komsuSayisi { get; set; }
            public Int64 katsayi { get; set; }
        }

        int benziyormu(Int64 A,Int64 B)
        {
            Int64 sayi3;
            sayi3 = A ^ B;            
            int benzerlik=0;
            for (int i = 0; i < girisSayisi; i++)                     
            { if ((sayi3 & 1) == 1)benzerlik++;
                sayi3 = sayi3 >> 1;           
            }
            return benzerlik;
        }

        int kapsaniyormu(Int64[] q00)    // süre uzuyor,...
        { 
          int sonuc=0; Int64[] C = new Int64[2];
          foreach (Int64[] q11 in q1_Kumesi)
            {
                C[0] = q00[0] & q11[0];
                C[1] = q00[1] & q11[1];
                Int64 bos = 4294967295;  //bu sayı Int64'de 111...111 degeri.
                bos = (C[0] | C[1]) ^ bos;
                if (q1_ler.Items.Count>0||bos == 0)
                {
                    if ((C[0] == q00[0]) && (C[1] == q00[1])) { sonuc = 1; break; } //q00 kapsaniyor
                    else if ((C[0] == q11[0]) && (C[1] == q11[1])) { q11[0] = q00[0]; q11[1] = q00[1]; sonuc = 2; break; } //q0 degeri q1'i kapsıyor, q1 degeri guncelleniyor 
                }
            }
            if (sonuc == 0) q1_Kumesi.Add(q00);
            return sonuc;            
        }

      
    }
}
